VST 3 SDK: VSTGUIEditor Class Reference
Author: Steinberg

VST 3 SDK VST 3.7 SDK for developing VST plug-in

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Member Functions | List of all members
VSTGUIEditor Class Referenceabstract
VST Implementation Helper Classes

Base class for an edit view using VSTGUI. More...

`#include <vstguieditor.h>`

Inheritance diagram for VSTGUIEditor:

## Public Member Functions
| VSTGUIEditor (void *controller, ViewRect *size=nullptr)
| Constructor.
virtual | ~VSTGUIEditor ()
| Destructor.
virtual bool | open (void *parent)=0
| Called when the editor will be opened.
virtual void | close ()=0
| Called when the editor will be closed.
void | setIdleRate (int32 millisec)
| Sets the idle rate controlling the parameter update rate.
VSTGUI::CMessageResult | notify (VSTGUI::CBaseObject *sender, const char *message) SMTG_OVERRIDE
void | forget () SMTG_OVERRIDE
void | remember () SMTG_OVERRIDE
long | getNbReference () const SMTG_OVERRIDE
tresult | isPlatformTypeSupported (FIDString type) SMTG_OVERRIDE
tresult | onSize (ViewRect *newSize) SMTG_OVERRIDE
void | beginEdit (long index) SMTG_OVERRIDE
| Called from VSTGUI when a user begins editing.
void | endEdit (long index) SMTG_OVERRIDE
| Called from VSTGUI when a user ends editing.
long | getKnobMode () const SMTG_OVERRIDE
OBJ_METHODS(VSTGUIEditor, EditorView) DEFINE_INTERFACES END_DEFINE_INTERFACES(EditorView) REFCOUNT_METHODS(EditorView) protected tresult | removed () SMTG_OVERRIDE
tresult | onKeyDown (char16 key, int16 keyMsg, int16 modifiers) SMTG_OVERRIDE
tresult | onKeyUp (char16 key, int16 keyMsg, int16 modifiers) SMTG_OVERRIDE
tresult | onWheel (float distance) SMTG_OVERRIDE
tresult | setFrame (IPlugFrame *frame) SMTG_OVERRIDE
Public Member Functions inherited from EditorView
| EditorView (EditController *controller, ViewRect *size=nullptr)
| ~EditorView () override
EditController * | getController () const
| Gets its controller part.
void | attachedToParent () SMTG_OVERRIDE
void | removedFromParent () SMTG_OVERRIDE
Public Member Functions inherited from CPluginView
| CPluginView (const ViewRect *rect=nullptr)
| ~CPluginView () SMTG_OVERRIDE
const ViewRect & | getRect () const
| Returns its current frame rectangle.
void | setRect (const ViewRect &r)
| Sets a new frame rectangle.
bool | isAttached () const
| Checks if this view is attached to its parent view.
tresult | isPlatformTypeSupported (FIDString type) SMTG_OVERRIDE
tresult | attached (void *parent, FIDString type) SMTG_OVERRIDE
tresult | removed () SMTG_OVERRIDE
tresult | onWheel (float) SMTG_OVERRIDE
tresult | onKeyDown (char16, int16, int16) SMTG_OVERRIDE
tresult | onKeyUp (char16, int16, int16) SMTG_OVERRIDE
tresult | getSize (ViewRect *size) SMTG_OVERRIDE
tresult | onSize (ViewRect *newSize) SMTG_OVERRIDE
tresult | onFocus (TBool) SMTG_OVERRIDE
tresult | setFrame (IPlugFrame *frame) SMTG_OVERRIDE
tresult | canResize () SMTG_OVERRIDE
tresult | checkSizeConstraint (ViewRect *) SMTG_OVERRIDE

## Additional Inherited Members
Public Attributes inherited from CPluginView
OBJ_METHODS(CPluginView, FObject) DEFINE_INTERFACES DEF_INTERFACE(IPlugView) END_DEFINE_INTERFACES(FObject) REFCOUNT_METHODS(FObject) protected void * | systemWindow {nullptr}
IPtr< IPlugFrame > | plugFrame
Static Public Attributes inherited from IPlugView
static const FUID | iid
Protected Attributes inherited from EditorView
IPtr< EditController > | controller

## Detailed Description

Base class for an edit view using VSTGUI.

## Constructor & Destructor Documentation

VSTGUIEditor | ( | void * | controller,
|  | ViewRect * | size = `nullptr`
| ) |  |

Constructor.

~VSTGUIEditor | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual bool open | ( | void * | parent | ) |
| pure virtual

Called when the editor will be opened.

virtual void close | ( |  | ) |
| pure virtual

Called when the editor will be closed.

void setIdleRate | ( | int32 | millisec | ) |

Sets the idle rate controlling the parameter update rate.

CMessageResult notify | ( | VSTGUI::CBaseObject * | sender,
|  | const char * | message
| ) |  |

void forget | ( |  | ) |
| inline

void remember | ( |  | ) |
| inline

long getNbReference | ( |  | ) | const
| inline

tresult isPlatformTypeSupported | ( | FIDString | type | ) |
| virtual

Implements IPlugView.

tresult onSize | ( | ViewRect * | newSize | ) |
| virtual

Implements IPlugView.

void beginEdit | ( | long | index | ) |

Called from VSTGUI when a user begins editing.

The default implementation calls performEdit of the EditController.

void endEdit | ( | long | index | ) |

Called from VSTGUI when a user ends editing.

The default implementation calls endEdit of the EditController.

long getKnobMode | ( |  | ) | const

tresult removed | ( |  | ) |
| virtual

Implements IPlugView.

tresult onKeyDown | ( | char16 | key,
|  | int16 | keyMsg,
|  | int16 | modifiers
| ) |  |
| virtual

Implements IPlugView.

tresult onKeyUp | ( | char16 | key,
|  | int16 | keyMsg,
|  | int16 | modifiers
| ) |  |
| virtual

Implements IPlugView.

tresult onWheel | ( | float | distance | ) |
| virtual

Implements IPlugView.

tresult setFrame | ( | IPlugFrame * | frame | ) |
| virtual

Implements IPlugView.

Empty

Copyright ©2024 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.